<?
/*
			$size   = filesize($file); // File size
			$length = $size;           // Content length
			$start  = 0;               // Start byte
			$end    = $size - 1;       // End byte
			// Now that we've gotten so far without errors we send the accept range header
			header("Accept-Ranges: 0-$length");
			// header('Accept-Ranges: bytes');
			// multipart/byteranges
			// http://www.w3.org/Protocols/rfc2616/rfc2616-sec19.html#sec19.2
			if (isset($_SERVER['HTTP_RANGE']))
			{
				$c_start = $start;
				$c_end   = $end;
				// Extract the range string
				list(, $range) = explode('=', $_SERVER['HTTP_RANGE'], 2);
				// Make sure the client hasn't sent us a multibyte range
				if (strpos($range, ',') !== false)
				{
					// (?) Shoud this be issued here, or should the first
					// range be used? Or should the header be ignored and
					// we output the whole content?
					header('HTTP/1.1 416 Requested Range Not Satisfiable');
					header("Content-Range: bytes $start-$end/$size");
					// (?) Echo some info to the client?
					exit;
				}
				// If the range starts with an '-' we start from the beginning
				// If not, we forward the file pointer
				// And make sure to get the end byte if spesified
				if ($range{0} == '-')
				{
					// The n-number of the last bytes is requested
					$c_start = $size - substr($range, 1);
				}
				else
				{
					$range  = explode('-', $range);
					$c_start = $range[0];
					$c_end   = (isset($range[1]) && is_numeric($range[1])) ? $range[1] : $size;
				}
				// End bytes can not be larger than $end.
				$c_end = ($c_end > $end) ? $end : $c_end;
				// Validate the requested range and return an error if it's not correct.
				if ($c_start > $c_end || $c_start > $size - 1 || $c_end >= $size)
				{
					header('HTTP/1.1 416 Requested Range Not Satisfiable');
					header("Content-Range: bytes $start-$end/$size");
					// (?) Echo some info to the client?
					exit;
				}
				$start  = $c_start;
				$end    = $c_end;
				$length = $end - $start + 1; // Calculate new content length
				fseek($fp, $start);
				header('HTTP/1.1 206 Partial Content');
			}
			// Notify the client the byte range we'll be outputting
			header("Content-Range: bytes $start-$end/$size");
			header("Content-Length: $length");
		}
		catch (Exception $e)
		{
			// We silently ignore error messages and try to output the file
			// Unless we're debugging.
			if ($settings['General']['Debug'])
			{
				echo $e;
			}
		}
		// Start buffered download
		$buffer = 1024 * 8;
		while(!feof($fp) && ($p = ftell($fp)) <= $end)
		{
			if ($p + $buffer > $end)
			{
				// In case we're only outputtin a chunk, make sure we don't
				// read past the length
				$buffer = $end - $p + 1;
			}
			set_time_limit(0); // Reset time limit for big files
			echo fread($fp, $buffer);
			flush(); // Free up memory. Otherwise large files will trigger PHP's memory limit.
		}
		fclose($fp);

*/

function html_show_begin($title)
{
  echo"<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"\n";
  echo"          \"http://www.w3.org/TR/2000/REC-xhtml1-20000126/DTD/xhtml1-strict.dtd\">\n";
  echo"<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"sk\" lang=\"sk\">\n";
  echo"<head>\n";
  printf("<title>%s</title>\n",strip_tags($title));
  echo"<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\" />\n";
  echo"<meta name=\"robots\" content=\"ALL\" />\n";
  echo"<style type=\"text/css\">\n";
  echo"a { font-weight: bold; color: blue; text-decoration: none; }\n";
  echo"a:hover { color: black; }\n";
  echo"h1 { font-size: 14pt; }\n";
  echo"</style>\n";
  echo"</head>\n";
  echo"<body>\n";
}

function html_show_end()
{
  echo'</body></html>';
}

function public_file_header($fname,$size=0,$dis=true,$fp=false)
{
  global $_SERVER;
  header("Content-Transfer-Encoding: binary");
  header('Cache-Control: public');
  header(sprintf("Content-Type: %s",mygetmime($fname)));
  header(sprintf("Content-Disposition: %s; filename=\"%s\"",($dis?'inline':'attachment'),$fname));

  $length=$size;
  $start=0;
  $end=$size-1;

  if($size<=0) return 0;
  if($fp===false){
    header("Content-Length: $length");
  }
  else{
    header(sprintf("Accept-Ranges: 0-%d",$length));

    if(isset($_SERVER['HTTP_RANGE'])){
      $c_start=$start;
      $c_end=$end;
      list(, $range) = explode('=', $_SERVER['HTTP_RANGE'], 2);

      if(strpos($range, ',')!==false){
        header('HTTP/1.1 416 Requested Range Not Satisfiable');
        header("Content-Range: bytes $start-$end/$size");
        return false;
      }

      if($range{0}=='-'){
        $c_start = $size - substr($range, 1);
      }
      else{
        $range=explode('-', $range);
        $c_start=$range[0];
        $c_end=(isset($range[1]) && is_numeric($range[1])) ? $range[1] : $size;
      }

      $c_end=($c_end>$end)?$end:$c_end;

      if($c_start>$c_end||$c_start>$size-1||$c_end>=$size){
        header('HTTP/1.1 416 Requested Range Not Satisfiable');
        header("Content-Range: bytes $start-$end/$size");
        return false;
      }

      $start=$c_start;
      $end=$c_end;
      $length=$end-$start+1;
      header('HTTP/1.1 206 Partial Content');
    }

    header("Content-Range: bytes $start-$end/$size");
    header("Content-Length: $length");

    fseek($fp, $start);

    $buffer = 1024 * 8;
    while(!feof($fp) && ($p = ftell($fp)) <= $end){
      if($p+$buffer>$end){
        $buffer = $end - $p + 1;
      }
      set_time_limit(0);
      echo fread($fp,$buffer);
      flush();
    }
  }
  return true;
}

function myexplode($cim,$text)
{
  $tok=strtok(trim($text),$cim);
  while($tok!==false){
    $p[]=trim($tok);
    $tok=strtok($cim);
  }
  return $p;
}


function mygetmime($ext)
{
  $type='application/octet-stream';

  $pos=mb_strrpos(mb_strtolower($ext),'.');
  if($pos===false) return $type;
  $ext=mb_substr($ext,$pos+1);
  
  $fname='mime.types';
  if(!is_file($fname)||!is_readable($fname)) return $type;
  $x=file($fname);
  
  foreach($x as $a){
    $a=trim($a);
    if(substr($a,0,1)=='#') continue;
    $a=myexplode(" \t",$a);
    if(count($a)<2) continue;
    for($i=1;$i<count($a);$i++){
      if($ext==$a[$i]){
        $type=$a[0];
	break;
      }
    }
  }
  
  return $type;
}

function donate()
{
?>
<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
<input type="hidden" name="cmd" value="_donations">
<input type="hidden" name="business" value="skupka@sageteam.eu">
<input type="hidden" name="item_name" value="mirror.bwpow.eu">
<input type="hidden" name="no_shipping" value="1">
<input type="hidden" name="no_note" value="1">
<input type="hidden" name="currency_code" value="EUR">
<input type="hidden" name="tax" value="0">
<input type="hidden" name="lc" value="SK">
<input type="hidden" name="bn" value="PP-DonationsBF">
<input type="image" src="https://www.paypal.com/en_US/i/btn/btn_donate_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
<img alt="" border="0" src="https://www.paypal.com/en_US/i/scr/pixel.gif" width="1" height="1">
</form>
<?
}

function read_cvinfo_helper($fname,$k)
{
  if(!is_file($fname)||!is_readable($fname)) return $k;
  $x=file($fname);
  
  $v='basic';
  foreach($x as $a){
    $a=trim($a);
    if(substr($a,0,1)=='['&&substr($a,-1)==']'){
      $v=substr($a,1,strlen($a)-2);
    }
    else{
      if($a!=''){
        $k[$v][]=myexplode(';',$a);
      }
    }
  }
  return $k;
}

function read_cvinfo($dir,$fname)
{
  $k=array();
  $k=read_cvinfo_helper(sprintf("%s/.%s.cvinfo",$dir,$fname),$k);
  $k=read_cvinfo_helper(sprintf("%s/.cvinfo",$dir),$k);
  return $k;  
}

function cv_to_text($cv,$t)
{
  $text='';
  if(!isset($cv[$t])) return $text;

  foreach($cv[$t] as $a){
    $x=implode(';',$a);
    $text.=sprintf("%s\n",$x);
  }
  
  return trim($text);
}

function cv_get_var($cv,$t,$t2)
{
  if(!isset($cv[$t])) return false;
  foreach($cv[$t] as $a){
    if(is_array($a)&&count($a)==2&&$a[0]==$t2) return $a[1];
  }
  return false;
}

$palicka_cnt=0;

function palicka()
{
  global $palicka_cnt;
  if($palicka_cnt>0){
    echo" | ";
  }
  $palicka_cnt++;
}

?>
